/*%CPW_START%*/
/*****************************************************************************
COPYRIGHT (c)  1993-95, VISIGENIC SOFTWARE, INC., ALL RIGHTS RESERVED.
THIS DOCUMENT CONTAINS TRADE SECRET DATA WHICH IS THE PROPERTY OF
VISIGENIC SOFTWARE, INC.  THIS DOCUMENT IS SUBMITTED TO RECIPIENT IN
CONFIDENCE.  INFORMATION CONTAINED HEREIN MAY NOT BE USED, COPIED OR
DISCLOSED IN WHOLE OR IN PART EXCEPT AS PERMITTED BY WRITTEN AGREEMENT
SIGNED BY VISIGENIC, INC.

THIS MATERIAL IS A CONFIDENTIAL TRADE SECRET AND PROPRIETARY
INFORMATION OF VISIGENIC SOFTWARE, INC., AND MAY NOT BE REPRODUCED,
USED, SOLD OR TRANSFERRED TO ANY THIRD PARTY WITHOUT THE PRIOR WRITTEN
CONSENT OF THE VISIGENIC SOFTWARE, INC. THIS MATERIAL IS ALSO
COPYRIGHTED AS AN UNPUBLISHED WORK UNDER TITLE 17 OF THE UNITED STATES
CODE.  UNAUTHORIZED USE, COPYING OR OTHER REPRODUCTION IS PROHIBITED
BY LAW.
*****************************************************************************/
/*
$Header:   /development/workarea1/visiroot/odbc/archives/drivers/syb/ctdb/vsinstsp.sql   1.1   Thu Oct 05 10:49:46 1995   vinay  $

$Log:   /development/workarea1/visiroot/odbc/archives/drivers/syb/ctdb/vsinstsp.sql  $
 * 
 *    Rev 1.1   Thu Oct 05 10:49:46 1995   vinay
 * Nam:  backport sp_tables from system 10 installmaster script
 * 
 *    Rev 1.0   Thu Aug 17 09:19:38 1995   ric
 * Initial PVCS Revision - renamed from instvgod.sql
 * 
 *    Rev 0.1   Sat Jul 08 17:02:10 1995   vinay
 * Changes to INSTVGOD.SQL as of 07/08/95:
 * 1. Fix sp_columns regression (remove offending
 *    ISNULL(NULL, ...) predicate).
 * 2. Add corrected sp_special_columns and sp_statistics.
 * 3. Add permission grants on tempdb.
 * 4. Fix "precison" -> "precision" for ODBC spec conformance.
 *
 *    Rev 0.0   Mon Jun 12 21:25:46 1995   vinay
*/
/*%CPW_END%*/
if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_datatype_info')
begin
	print "Dropping sp_datatype_info"
	drop procedure sp_datatype_info
end
go

/* Sccsid = "@(#) generic/sproc/a_mstables 105.1 2/3/94" */

/*
** This file creates the tables needed for the Microsoft stored procedures.
** It also loads the needed values into those tables.
** The tables are:
**	spt_datatype_info_ext
**	spt_datatype_info
**	spt_server_info
*/



/*
** spt_datatype_info_ext
*/
if (exists (select * from sysobjects
		where name = 'spt_datatype_info_ext' and type = 'U'))
    drop table spt_datatype_info_ext
go
create table spt_datatype_info_ext 
(
	user_type	smallint  not null, 
	create_params	varchar(32) null
)
go

grant select on spt_datatype_info_ext to public
go


insert into spt_datatype_info_ext
	/* CHAR 	 user_type, create_params */
	values			 (1, "length" )

insert into spt_datatype_info_ext
	/* VARCHAR	 user_type, create_params */
	values			 (2, "max length" )

insert into spt_datatype_info_ext
	/* BINARY	 user_type, create_params */
	values			 (3, "length" )

insert into spt_datatype_info_ext
	/* VARBINARY user_type, create_params */
	values			 (4, "max length" )

insert into spt_datatype_info_ext
	/* SYSNAME	 user_type, create_params */
	values			 (18, "max length" )
go

/* 
** spt_datatype_info
*/
if (exists (select * from sysobjects
		where name = 'spt_datatype_info' and type = 'U'))
    drop table spt_datatype_info
go
create table spt_datatype_info 
(
	ss_dtype	   tinyint	not null, 
	type_name          varchar(32)  not null, 
	data_type          smallint     not null, 
	data_precision     int          null, 
	numeric_scale      smallint     null, 
	numeric_radix      smallint     null, 
	length             int          null, 
	literal_prefix     varchar(32)  null, 
	literal_suffix     varchar(32)  null, 
	create_params      varchar(32)  null, 
	nullable           smallint     not null, 
	case_sensitive     smallint     not null, 
	searchable         smallint     not null, 
	unsigned_attribute smallint     null, 
	money              smallint     not null, 
	auto_increment     smallint     null, 
	local_type_name    varchar(128) not null, 
	aux                int          null
)
go

grant select on spt_datatype_info to public
go

/*
**	There is a complicated set of SQL used to deal with
**	the SQL Server Null data types (MONEYn, INTn, etc.)
**	ISNULL is the only conditional SQL Server function that can be used
**	to differentiate between these types depending on size.
**
**	The aux column in the above table is used to differentiate
**	the null data types from the non-null types.
**
**	The aux column contains NULL for the null data types and 0
**	for the non-null data types.
**
**	The following SQL returns the contents of the aux column (0)
**	for the non-null data types and returns a variable non-zero
**	value for the null data types.
**
**			 " I   I I FFMMDD"
**			 " 1   2 4 484848"
**	isnull(d.aux, ascii(substring("666AAA@@@CB??GG", 
**	2*(d.ss_dtype%35+1)+2-8/c.length, 1))-60)
**
**	The '2*(d.ss_dtype%35+1)+2-8/c.length' selects a specific character of
**	the substring mask depending on the null data type and its size, i.e.
**	null MONEY4 or null MONEY8.  The character selected is then converted
**	to its binary value and an appropriate bias (i.e. 60) is subtracted to
**	return the correct non-zero value.	This value may be used as a
**	constant, i.e. ODBC data type, precision, scale, etc., or used as an
**	index with a substring to pick out a character string, i.e. type name.
**
**	The comments above the substring mask denote which character is
**	selected for each null data type, i.e. In (INTn), Fn (FLOATn), 
**	Mn (MONEYn) and Dn (DATETIMn).
*/


declare @case smallint

select @case = 0
select @case = 1 where 'a' != 'A'

/* Local Binary */
insert into spt_datatype_info values
/* ss_type, name, data_type, prec, scale, rdx, len, prf, suf, 
** cp, nul, case, srch, unsigned, money, auto, local, aux 
*/
(45, "binary", -2, null, null, null, null, "0x", null, 
	"length", 1, 0, 2, null, 0, null, "binary", 0)

/* Local Bit */
insert into spt_datatype_info values
(50, "bit", -7, 1, 0, 2, null, null, null, 
 null, 0, 0, 2, null, 0, null, "bit", 0)

/* Local Char */
insert into spt_datatype_info values
(47, "char", 1, null, null, null, null, "'", "'", 
"length", 1, @case, 3, null, 0, null, "char", 0)

/* Local Datetime */
insert into spt_datatype_info values
(61, "datetime", 11, 23, 3, 10, 16, "'", "'", 
 null, 1, 0, 3, null, 0, null, "datetime", 0)

/* Local Smalldatetime */
insert into spt_datatype_info values
(58, "smalldatetime", 11, 16, 0, 10, 16, "'", "'", 
null, 1, 0, 3, null, 0, null, "smalldatetime", 0)

/* Local Datetimn  sql server type is "datetimn" */
insert into spt_datatype_info values
(111, "smalldatetime", 0, 0, 0, 10, 0, "'", "'", 
null, 1, 0, 3, null, 0, null, "datetime", null)

/**************************************************
*** Not supported Sybase 4.X **********************
* Decimal sql server type is "decimal" *
insert into spt_datatype_info values
(55, "decimal", 3, 0, 0, 10, 0, null, null,
null, 1, 0, 2, 0, 0, 0, "decimal", 0)

* Numeric sql server type is "numeric" *
insert into spt_datatype_info values
(63, "numeric", 2, 0, 0, 10, 0, null, null,
null, 1, 0, 2, 0, 0, 0, "numeric", 0)

* Double precision sql server type is "double precision" *
insert into spt_datatype_info values
(62, "double precision", 8, 15, null, 10, null, null, null,
null, 1, 0, 2, 0, 0, 0, "double precision", 0)

****************************************************/


/* Local Float */
insert into spt_datatype_info values
(62, "float", 6, 15, null, 10, null, null, null, 
null, 1, 0, 2, 0, 0, 0, "float", 0)

/* Local RealFloat   sql server type is "floatn" */
insert into spt_datatype_info values
(109, "float        real", 0, 0, null, 10, 0, null, null, 
null, 1, 0, 2, 0, 0, 0, "real      float", null)

/* Local Real */
insert into spt_datatype_info values
(59, "real", 7, 7, null, 10, null, null, null,
null, 1, 0, 2, 0, 0, 0, "real", 0)

/* Local Smallmoney */
insert into spt_datatype_info values
(122, "smallmoney", 3, 10, 4, 10, null, "$", null, 
null, 1, 0, 2, 0, 1, 0, "smallmoney", 0)

/* Local Int */
insert into spt_datatype_info values
(56, "int", 4, 10, 0, 10, null, null, null, 
null, 1, 0, 2, 0, 0, 0, "int", 0)

/* Local Intn  sql server type is "intn" */
insert into spt_datatype_info values
(38, "smallint     tinyint", 0, 0, 0, 10, 0, null, null, 
null, 1, 0, 2, 0, 0, 0, "tinyint   smallint", null)

/* Local Money */
insert into spt_datatype_info values
(60, "money", 3, 19, 4, 10, null, "$", null, 
null, 1, 0, 2, 0, 1, 0, "money", 0)

/* Local Moneyn  sql server type is "moneyn" */
insert into spt_datatype_info values
(110, "smallmoney", 0, 0, 4, 10, 0, "$", null, 
null, 1, 0, 2, 0, 1, 0, "smallmoneymoney", null)

/* Local Smallint */
insert into spt_datatype_info values
(52, "smallint", 5, 5, 0, 10, null, null, null, 
null, 1, 0, 2, 0, 0, 0, "smallint", 0)

/* Local Text */
insert into spt_datatype_info values
(35, "text", -1, 2147483647, null, null, 2147483647, "'", "'", 
null, 1, @case, 1, null, 0, null, "text", 0)

/* Local Varbinary */
insert into spt_datatype_info values
(37, "varbinary", -3, null, null, null, null, "0x", null, 
"max length", 1, 0, 2, null, 0, null, "varbinary", 0)

/* Local Tinyint */
insert into spt_datatype_info values
(48, "tinyint", -6, 3, 0, 10, null, null, null, 
null, 1, 0, 2, 1, 0, 0, "tinyint", 0)

/* Local Varchar */
insert into spt_datatype_info values
(39, "varchar", 12, null, null, null, null, "'", "'", 
"max length", 1, @case, 3, null, 0, null, "varchar", 0)

/* Local Image */
insert into spt_datatype_info values
(34, "image", -4, 2147483647, null, null, 2147483647, "0x", null, 
null, 1, 0, 1, null, 0, null, "image", 0)
go

dump tran master with truncate_only
go

/*
** spt_server_info
*/
if (exists (select * from sysobjects
		where name = 'spt_server_info' and type = 'U'))
    drop table spt_server_info
go
create table spt_server_info (
	  attribute_id		int, 
	  attribute_name	varchar(60), 
	  attribute_value	varchar(255))
go

insert into spt_server_info
	values (1, "DBMS_NAME", "SQL Server")
insert into spt_server_info
	values (2, "DBMS_VER", @@version)
insert into spt_server_info
	values (6, "DBE_NAME", "")
insert into spt_server_info
	values (10, "OWNER_TERM", "owner")
insert into spt_server_info
	values (11, "TABLE_TERM", "table")
insert into spt_server_info
	values (12, "MAX_OWNER_NAME_LENGTH", "30")
insert into spt_server_info
	values (16, "IDENTIFIER_CASE", "MIXED")
insert into spt_server_info
	values (15, "COLUMN_LENGTH", "30")
insert into spt_server_info
	values (13, "TABLE_LENGTH", "30")
insert into spt_server_info
	values (100, "USERID_LENGTH", "30")
insert into spt_server_info
	values (17, "TX_ISOLATION", "2")
insert into spt_server_info
	values (18, "COLLATION_SEQ", "")
insert into spt_server_info
	values (14, "MAX_QUAL_LENGTH", "30")
insert into spt_server_info
	values (101, "QUALIFIER_TERM", "database")
insert into spt_server_info
	values (19, "SAVEPOINT_SUPPORT", "Y")
insert into spt_server_info
	values (20, "MULTI_RESULT_SETS", "Y")
insert into spt_server_info
	values (102, "NAMED_TRANSACTIONS", "Y")
insert into spt_server_info
	values (103, "SPROC_AS_LANGUAGE", "Y")
insert into spt_server_info
	values (103, "REMOTE_SPROC", "Y")
insert into spt_server_info
	values (22, "ACCESSIBLE_TABLES", "Y")
insert into spt_server_info
	values (104, "ACCESSIBLE_SPROC", "Y")
insert into spt_server_info
	values (105, "MAX_INDEX_COLS", "16")
insert into spt_server_info
	values (106, "RENAME_TABLE", "Y")
insert into spt_server_info
	values (107, "RENAME_COLUMN", "Y")
insert into spt_server_info
	values (108, "DROP_COLUMN", "N")
insert into spt_server_info
	values (109, "INCREASE_COLUMN_LENGTH", "N")
insert into spt_server_info
	values (110, "DDL_IN_TRANSACTION", "N")
insert into spt_server_info
	values (111, "DESCENDING_INDEXES", "N")
insert into spt_server_info
	values (112, "SP_RENAME", "Y")
go
/*
** NOTE: the following applies to Microsoft changes, not Sybase.  Do not change
** for Sybase check-ins unless we are synchronizing with Microsoft changes.
**
** The last row in spt_server_info has been used as the version number of the 
** file. The convention is jj.nn.dddd, where:
** 	jj is the major version number ("01" now), 
**	nn is the minor version number ("01" now), and 
**	dddd is the date in the form of month and day (mmdd) of the date you 
**	check in this file.  Add (current year-1991)*12 to the month to keep 
**	in sync with the driver version numbers.  Checking in on Feb 5 1993
**	would mean setting the value to 01.01.2605.
**
*/
insert into spt_server_info
	values (500, "SYS_SPROC_VERSION", "99.99.0001")
go

if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_datatype_info')
begin
	drop procedure sp_datatype_info
end
go
print "Installing sp_datatype_info"
go


/* 
** Sccsid = "@(#) generic/sproc/datatype_info 105.1 2/3/94"
**
** History:
**	10.0	steven	1.1	07/13/93	sproc/src/datatype_info
**						Ported from MS catalog SP's
**
** Implementation Notes:
** 	The messiness of 'sp_data_type_info' was to get around the
** problem of returning the correct lengths for user defined types.  The
** join on the type name ensures all user defined types are returned, but
** this puts a null in the data_type column.  By forcing an embedded
** select and correlating it with the current row in systypes, we get the
** correct data_type mapping even for user defined types.  
*/

create procedure sp_datatype_info
@data_type int = 0			/* Provide datatype_info for type # */
as
	if (select @data_type) = 0
		select	/* Real SQL Server data types */
			type_name = t.name,
			d.data_type,
			"precision" = isnull(d.data_precision, 
					    convert(int,t.length)),
			d.literal_prefix,
			d.literal_suffix,
			e.create_params,
			d.nullable,
			d.case_sensitive,
			d.searchable,
			d.unsigned_attribute,
			d.money,
			d.auto_increment,
			d.local_type_name
		from 	master.dbo.spt_datatype_info d, 
			master.dbo.spt_datatype_info_ext e, systypes t
		where
			d.ss_dtype = t.type
			and t.usertype *= e.user_type
			    /* restrict results to "real" datatypes */
			and t.name not in ("nchar","nvarchar",
					   "sysname","timestamp",
					   "datetimn","floatn","intn","moneyn")
			and t.usertype < 100	/* No user defined types */
		UNION
		select	/* SQL Server user data types */
			type_name = t.name,
			d.data_type,
			"precision" = isnull(d.data_precision, 
					    convert(int,t.length)),
			d.literal_prefix,
			d.literal_suffix,
			e.create_params,
			d.nullable,
			d.case_sensitive,
			d.searchable,
			d.unsigned_attribute,
			d.money,
			d.auto_increment,
			t.name
		from 	master.dbo.spt_datatype_info d, 
			master.dbo.spt_datatype_info_ext e, systypes t
		where
			d.ss_dtype = t.type
			and t.usertype *= e.user_type
			    /* 
			    ** Restrict to user defined types (value > 100)
			    ** and Sybase user defined types (listed)
			    */
			and (t.name in (/* "nchar","nvarchar", */
					    "sysname","timestamp")
			    or t.usertype >= 100)      /* User defined types */
		order by d.data_type, type_name
	else
		select	/* Real SQL Server data types */
			type_name = t.name,
			d.data_type,
			"precision" = isnull(d.data_precision, 
					    convert(int,t.length)),
			d.literal_prefix,
			d.literal_suffix,
			e.create_params,
			d.nullable,
			d.case_sensitive,
			d.searchable,
			d.unsigned_attribute,
			d.money,
			d.auto_increment,
			d.local_type_name
		from 	master.dbo.spt_datatype_info d, 
			master.dbo.spt_datatype_info_ext e, systypes t
		where
			data_type = @data_type
			and d.ss_dtype = t.type
			and t.usertype *= e.user_type
			    /* restrict results to "real" datatypes */
			and t.name not in ("nchar","nvarchar",
					   "sysname","timestamp",
					   "datetimn","floatn","intn","moneyn")
			and t.usertype < 100	/* No user defined types */
		UNION
		select	/* SQL Server and user data types */
			type_name = t.name,
			d.data_type,
			"precision" = isnull(d.data_precision, 
					    convert(int,t.length)),
			d.literal_prefix,
			d.literal_suffix,
			e.create_params,
			d.nullable,
			d.case_sensitive,
			d.searchable,
			d.unsigned_attribute,
			d.money,
			d.auto_increment,
			t.name
		from 	master.dbo.spt_datatype_info d, 
			master.dbo.spt_datatype_info_ext e, systypes t
		where
			data_type = @data_type
			and d.ss_dtype = t.type
			and t.usertype *= e.user_type
			    /* 
			    ** Restrict to user defined types (value > 100)
			    ** and Sybase user defined types (listed)
			    */
			and (t.name in (/* "nchar","nvarchar", */
					    "sysname","timestamp")
			    or t.usertype >= 100)     /* User defined types */
		order by type_name
return (0)
go
grant execute on sp_datatype_info to public
go
/* SP_COLUMNS */
if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_columns')
begin
	drop procedure sp_columns
end
go
print "Installing sp_columns"
go

/* Sccsid = "@(#) generic/sproc/columns 108.2.56619 6/29/94 " */
/*      10.0        07/20/93        sproc/columns */
 

/* This is the version for servers which support UNION */

/* This routine is intended for support of ODBC connectivity.  Under no
** circumstances should changes be made to this routine unless they are
** to fix ODBC related problems.  All other users are at there own risk!
*/

CREATE PROCEDURE sp_columns (
				 @table_name		varchar(32),
				 @table_owner		varchar(32) = null,
				 @table_qualifier	varchar(32) = null,
				 @column_name		varchar(32) = null )
AS
    declare @full_table_name    char(70)
    declare @table_id int

    if @column_name is null /*	If column name not supplied, match all */
	select @column_name = '%'

    /* Check if the current database is the same as the one provided */
    if @table_qualifier is not null
    begin
		if db_name() != @table_qualifier
		begin	/* 
			** If qualifier doesn't match current database 
			** 18039, Table qualifier must be name of current database
			*/
                        print "Table qualifier must be name of current database"
                        return (1)

		end
    end

    if @table_name is null
    begin	/*	If table name not supplied, match all */
		select @table_name = '%'
    end

    if @table_owner is null
    begin	/* If unqualified table name */
		SELECT @full_table_name = @table_name
    end
    else
    begin	/* Qualified table name */
		SELECT @full_table_name = @table_owner + '.' + @table_name
    end

    /* Get Object ID */
    SELECT @table_id = object_id(@full_table_name)


    /* If the table name parameter is valid, get the information */ 
    if ((charindex('%',@full_table_name) = 0) and
		(charindex('_',@full_table_name) = 0)  and
		@table_id != 0)
    begin
		/* 
		** This block is for the case where there is no pattern
		** matching required for the table name
		*/
		SELECT	/* INTn, FLOATn, DATETIMEn and MONEYn types */
			table_qualifier = DB_NAME(),
			table_owner = USER_NAME(o.uid),
			table_name = o.name,
			column_name = c.name,
			data_type = d.data_type+convert(smallint,
						isnull(d.aux,
						ascii(substring("666AAA@@@CB??GG",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))
						-60)),
			type_name = rtrim(substring(d.type_name,
						1+isnull(d.aux,
						ascii(substring("III<<<MMMI<<A<A",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60), 13)),
			precision = isnull(d.data_precision, convert(int,c.length))
						+isnull(d.aux, convert(int,
						ascii(substring("???AAAFFFCKFOLS",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))-60)),
			length = isnull(d.length, convert(int,c.length)) +convert(int,
						isnull(d.aux,
						ascii(substring("AAA<BB<DDDHJSPP",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-64)),
			scale = d.numeric_scale +convert(smallint,
						isnull(d.aux,
						ascii(substring("<<<<<<<<<<<<<<?",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60)),
			radix = d.numeric_radix,
			nullable =	/* set nullability from status flag */
				convert(smallint, convert(bit, c.status&8)),
			remarks = convert(varchar(254),null),	/* Remarks are NULL */
			ss_data_type = c.type,
			colid = c.colid
		FROM
			syscolumns c,
			sysobjects o,
			master.dbo.spt_datatype_info d,
			systypes t
		WHERE
			o.id = @table_id
			AND c.id = o.id
			/*
			** We use syscolumn.usertype instead of syscolumn.type
			** to do join with systypes.usertype. This is because
			** for a column which allows null, type stores its
			** Server internal datatype whereas usertype still
			** stores its user defintion datatype.  For an example,
			** a column of type 'decimal NULL', its usertype = 26,
			** representing decimal whereas its type = 106 
			** representing decimaln. nullable in the select list
			** already tells user whether the column allows null.
			** In the case of user defining datatype, this makes
			** more sense for the user.
			*/
			AND c.usertype = t.usertype
			AND t.type = d.ss_dtype
			AND c.name like @column_name
			AND d.ss_dtype IN (111, 109, 38, 110)	/* Just *N types */
			AND c.usertype < 100		/* No user defined types */
		UNION
		SELECT /* All other types including user data types */
			table_qualifier = DB_NAME(),
			table_owner = USER_NAME(o.uid),
			table_name = o.name,
			column_name = c.name,
			data_type = d.data_type+convert(smallint,
						isnull(d.aux,
						ascii(substring("666AAA@@@CB??GG",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))
						-60)),
			type_name = rtrim(substring(d.type_name,
						1+isnull(d.aux,
						ascii(substring("III<<<MMMI<<A<A",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60), 13)),
			precision = isnull(d.data_precision, convert(int,c.length))
						+isnull(d.aux, convert(int,
						ascii(substring("???AAAFFFCKFOLS",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))-60)),
			length = isnull(d.length, convert(int,c.length)) +convert(int,
						isnull(d.aux,
						ascii(substring("AAA<BB<DDDHJSPP",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-64)),
			scale = d.numeric_scale +convert(smallint,
						isnull(d.aux,
						ascii(substring("<<<<<<<<<<<<<<?",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60)),
			radix = d.numeric_radix,
			nullable =	/* set nullability from status flag */
				convert(smallint, convert(bit, c.status&8)),
			remarks = convert(varchar(254),null),	/* Remarks are NULL */
			ss_data_type = c.type,
			colid = c.colid
		FROM
			syscolumns c,
			sysobjects o,
			master.dbo.spt_datatype_info d,
			systypes t
		WHERE
			o.id = @table_id
			AND c.id = o.id
			/*
			** We use syscolumn.usertype instead of syscolumn.type
			** to do join with systypes.usertype. This is because
			** for a column which allows null, type stores its
			** Server internal datatype whereas usertype still
			** stores its user defintion datatype.  For an example,
			** a column of type 'decimal NULL', its usertype = 26,
			** representing decimal whereas its type = 106 
			** representing decimaln. nullable in the select list
			** already tells user whether the column allows null.
			** In the case of user defining datatype, this makes
			** more sense for the user.
			*/
			AND c.usertype = t.usertype
			/*
			** We need a equality join with 
			** master.dbo.spt_datatype_info here so that
			** there is only one qualified row returned from 
			** master.dbo.spt_datatype_info, thus avoiding
			** duplicates.
			*/
			AND t.type = d.ss_dtype
			AND c.name like @column_name
			AND (d.ss_dtype NOT IN (111, 109, 38, 110) /* No *N types */
				OR c.usertype >= 100) /* User defined types */
			 ORDER BY colid
	end
	else
    begin
		/* 
		** This block is for the case where there IS pattern
		** matching done on the table name. 
		*/
		if @table_owner is null /* If owner not supplied, match all */
			select @table_owner = '%'

		SELECT	/* INTn, FLOATn, DATETIMEn and MONEYn types */
			table_qualifier = DB_NAME(),
			table_owner = USER_NAME(o.uid),
			table_name = o.name,
			column_name = c.name,
			data_type = d.data_type+convert(smallint,
						isnull(d.aux,
						ascii(substring("666AAA@@@CB??GG",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))
						-60)),
			type_name = rtrim(substring(d.type_name,
						1+isnull(d.aux,
						ascii(substring("III<<<MMMI<<A<A",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60), 13)),
			precision = isnull(d.data_precision, convert(int,c.length))
						+isnull(d.aux, convert(int,
						ascii(substring("???AAAFFFCKFOLS",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))-60)),
			length = isnull(d.length, convert(int,c.length)) +convert(int,
						isnull(d.aux,
						ascii(substring("AAA<BB<DDDHJSPP",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-64)),
			scale = d.numeric_scale +convert(smallint,
						isnull(d.aux,
						ascii(substring("<<<<<<<<<<<<<<?",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60)),
			radix = d.numeric_radix,
			nullable =	/* set nullability from status flag */
				convert(smallint, convert(bit, c.status&8)),
			remarks = convert(varchar(254),null),	/* Remarks are NULL */
			ss_data_type = c.type,
			colid = c.colid
		FROM
			syscolumns c,
			sysobjects o,
			master.dbo.spt_datatype_info d,
			systypes t
		WHERE
			o.name like @table_name
			AND user_name(o.uid) like @table_owner
			AND o.id = c.id
			/*
			** We use syscolumn.usertype instead of syscolumn.type
			** to do join with systypes.usertype. This is because
			** for a column which allows null, type stores its
			** Server internal datatype whereas usertype still
			** stores its user defintion datatype.  For an example,
			** a column of type 'decimal NULL', its usertype = 26,
			** representing decimal whereas its type = 106 
			** representing decimaln. nullable in the select list
			** already tells user whether the column allows null.
			** In the case of user defining datatype, this makes
			** more sense for the user.
			*/
			AND c.usertype = t.usertype
			AND t.type = d.ss_dtype
			AND o.type != 'P'
			AND c.name like @column_name
			AND d.ss_dtype IN (111, 109, 38, 110)	/* Just *N types */
			AND c.usertype < 100
		UNION
		SELECT /* All other types including user data types */
			table_qualifier = DB_NAME(),
			table_owner = USER_NAME(o.uid),
			table_name = o.name,
			column_name = c.name,
			data_type = d.data_type+convert(smallint,
						isnull(d.aux,
						ascii(substring("666AAA@@@CB??GG",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))
						-60)),
			type_name = rtrim(substring(d.type_name,
						1+isnull(d.aux,
						ascii(substring("III<<<MMMI<<A<A",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60), 13)),
			precision = isnull(d.data_precision, convert(int,c.length))
						+isnull(d.aux, convert(int,
						ascii(substring("???AAAFFFCKFOLS",
						2*(d.ss_dtype%35+1)+2-8/c.length,1))-60)),
			length = isnull(d.length, convert(int,c.length)) +convert(int,
						isnull(d.aux,
						ascii(substring("AAA<BB<DDDHJSPP",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-64)),
			scale = d.numeric_scale +convert(smallint,
						isnull(d.aux,
						ascii(substring("<<<<<<<<<<<<<<?",
						2*(d.ss_dtype%35+1)+2-8/c.length,
						1))-60)),
			radix = d.numeric_radix,
			nullable =	/* set nullability from status flag */
				convert(smallint, convert(bit, c.status&8)),
			remarks  = convert(varchar(254),null),
			ss_data_type = c.type,
			colid = c.colid
		FROM
			syscolumns c,
			sysobjects o,
			master.dbo.spt_datatype_info d,
			systypes t
		WHERE
			o.name like @table_name
			AND user_name(o.uid) like @table_owner
			AND o.id = c.id
			/*
			** We use syscolumn.usertype instead of syscolumn.type
			** to do join with systypes.usertype. This is because
			** for a column which allows null, type stores its
			** Server internal datatype whereas usertype still
			** stores its user defintion datatype.  For an example,
			** a column of type 'decimal NULL', its usertype = 26,
			** representing decimal whereas its type = 106 
			** representing decimaln. nullable in the select list
			** already tells user whether the column allows null.
			** In the case of user defining datatype, this makes
			** more sense for the user.
			*/
			AND c.usertype = t.usertype
			/*
			** We need a equality join with 
			** master.dbo.spt_datatype_info here so that
			** there is only one qualified row returned from 
			** master.dbo.spt_datatype_info, thus avoiding
			** duplicates.
			*/
			AND t.type = d.ss_dtype
			AND c.name like @column_name
			AND o.type != 'P'
			AND c.name like @column_name
			AND (d.ss_dtype NOT IN (111, 109, 38, 110) /* No *N types */
				OR c.usertype >= 100) /* User defined types */
		ORDER BY table_owner, table_name, colid
	end
	
	return(0)
go
grant execute on sp_columns to public
go

if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_special_columns')
begin
	drop procedure sp_special_columns
end
go
print "Installing sp_special_columns"
go

/* Sccsid = "@(#) generic/sproc/special_columns 105.1 2/3/94" */
/*	10.0	1.0	9 JUL 93	sproc/src/special_columns */

/* 
** Messages for "sp_special_columns"
**
** 17863, "There is no table named %1! in the current database."
** 18039, "Table qualifier must be name of current database."
** 18042, "Illegal value for 'col_type' argument. Legal values are 'V' or 'R'."
**
*/

create procedure sp_special_columns (
				 @table_name		varchar(32),
				 @table_owner		varchar(32) = null,
				 @table_qualifier	varchar(32) = null,
				 @col_type		char(1) = 'R' )
as
	declare @indid			int
	declare @table_id		int
	declare @dbname			char(30)
	declare @full_table_name	char(70)
	declare @msg			char(70)

	/* get database name */
	select @dbname = db_name()

	/* we don't want a temp table unless we're in tempdb */
	if @table_name like "#%" and @dbname != "tempdb"
	begin	
		print "Table %1 does not exist", @table_name
		return (1)
	end

	if @table_qualifier is not null
	begin
		/* if qualifier doesn't match current database */
		if @dbname != @table_qualifier
		begin	
			print "Table qualifier must be name of current database."
			return (1)
		end
	end

	if @table_owner is null
	begin	/* if unqualified table name */
		select @full_table_name = @table_name
	end
	else
	begin	/* qualified table name */
		select @full_table_name = @table_owner + '.' + @table_name
	end

	/* get object ID */
	select @table_id = object_id(@full_table_name)

	if @col_type = 'V'
	begin /* if ROWVER, just run that query */
		select
			scope = convert(smallint, 0),
			column_name = c.name,
			data_type = d.data_type + convert(smallint,
					isnull(d.aux,
					ascii(substring("666AAA@@@CB??GG",
					2*(d.ss_dtype%35+1)+2-8/c.length,1))
					-60)),
			type_name = t.name,
			"precision" = isnull(d.data_precision,
					convert(int,c.length))
					+ isnull(d.aux, convert(int,
					ascii(substring("???AAAFFFCKFOLS",
					2*(d.ss_dtype%35+1)+2-8/c.length,1))
					-60)),
			length = isnull(d.length, convert(int,c.length))
					+ convert(int,
					isnull(d.aux,
					ascii(substring("AAA<BB<DDDHJSPP",
					2*(d.ss_dtype%35+1)+2-8/c.length, 1))
					-64)),
			scale = d.numeric_scale + convert(smallint,
					isnull(d.aux,
					ascii(substring("<<<<<<<<<<<<<<?",
					2*(d.ss_dtype%35+1)+2-8/c.length, 1))
					-60))
		from
			systypes t, syscolumns c, spt_datatype_info d
		where
			c.id = @table_id
			and c.type = d.ss_dtype
			and c.usertype = 80	/* TIMESTAMP */
			and t.usertype = 80	/* TIMESTAMP */
		return (0)
	end

	if @col_type != 'R'
	begin
		/* 
		** msg 18042
		** Illegal value for 'col_type' argument. Legal values 
		** are 'V' or 'R'. 
		*/

		print "Illegal value for 'col_type' argument. Legal values are 'V' or 'R'."
		return (1)
	end

	/* ROWID, now find the id of the 'best' index for this table */

	select @indid = (
		select min(indid)
		from sysindexes
		where
			status & 2 = 2		/* if unique index */
			and id = @table_id
			and indid > 0)		/* eliminate table row */

	 select
		scope = convert(smallint, 0),
		column_name = index_col(@full_table_name,indid,c.colid),
		data_type = d.data_type + convert(smallint,
					isnull(d.aux,
					ascii(substring("666AAA@@@CB??GG",
					2*(d.ss_dtype%35+1)+2-8/c2.length,1))
					-60)),
		type_name = rtrim(substring(d.type_name,
					1 + isnull(d.aux,
					ascii(substring("III<<<MMMI<<A<A",
					2*(d.ss_dtype%35+1)+2-8/c2.length, 1))
					-60), 13)),
		"precision" = isnull(d.data_precision, convert(int,c2.length))
					+ isnull(d.aux, convert(int,
					ascii(substring("???AAAFFFCKFOLS",
					2*(d.ss_dtype%35+1)+2-8/c2.length,1))
					-60)),
		length = isnull(d.length, convert(int,c2.length))
					+ convert(int, isnull(d.aux,
					ascii(substring("AAA<BB<DDDHJSPP",
					2*(d.ss_dtype%35+1)+2-8/c2.length, 1))
					-64)),
		scale = d.numeric_scale + convert(smallint,
					isnull(d.aux,
					ascii(substring("<<<<<<<<<<<<<<?",
					2*(d.ss_dtype%35+1)+2-8/c2.length, 1))
					-60))
	from
		sysindexes x,
		syscolumns c,
		spt_datatype_info d,
		systypes t,
		syscolumns c2	/* self-join to generate list of index
				** columns and to extract datatype names */
	where
		x.id = @table_id
		and c2.name = index_col(@full_table_name, @indid,c.colid)
		and c2.id =x.id
		and c.id = x.id
		and c.colid < keycnt + (x.status & 16) / 16
		and x.indid = @indid
		and c2.type = d.ss_dtype
		and c2.usertype *= t.usertype

	return (0)
go
grant execute on sp_special_columns to public
go
dump tran master with truncate_only
go

if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_statistics')
begin
	drop procedure sp_statistics
end
go
print "Installing sp_statistics"
go

/* Sccsid = "@(#) generic/sproc/statistics 105.1 2/3/94" */

/*
** Messages for "sp_statistics"          18039
**
** 18039, "Table qualifier must be name of current database."
** 18040, "Catalog procedure '%1!' can not be run in a transaction.
**
*/

/*
** Sp_statistics returns statistics for the given table, passed as first 
** argument. A row is returned for the table and then for each index found
** in sysindexes, starting with lowest value index id in sysindexes and 
** proceeding through the highest value index.  
**
** Returned rows consist of the columns:
** table qualifier (database name), table owner, table name from sysobjects, 
** non_unique (0/1), index qualifier (same as table name), 
** index name from sysindexes, type (SQL_INDEX_CLUSTERED/SQL_INDEX_OTHER), 
** sequence in index, column name, collation (currently, this is always "A"), 
** table cardinality (row count), and number of pages used by table (doampg).
*/

create procedure sp_statistics (
	@table_name		varchar(32),
	@table_owner		varchar(32) = null,
	@table_qualifier	varchar(32) = null,
	@index_name		varchar(32) = '%',
	@is_unique 		char(1) = 'N')
as
declare @indid			int
declare @lastindid		int
declare @full_table_name	char(70)
declare @msg 			varchar(250)

/*
** Verify table qualifier is name of current database.
*/
if @table_qualifier is not null
begin
	if db_name() != @table_qualifier
	begin	/* If qualifier doesn't match current database */
		/*
		** 18039, "Table qualifier must be name of current database."
		*/
		print "Table qualifier must be name of current database."
		return (1)
	end
end

create table #TmpIndex(
	table_qualifier	varchar(32),
	table_owner	varchar(32),
	table_name	varchar(32),
	index_qualifier varchar(32) null,
	index_name	varchar(32) null,
	non_unique	smallint null,
	type		smallint,
	seq_in_index	smallint null,
	column_name	varchar(32) null,
	collation	char(1) null,
	index_id	int null,
	cardinality	int null,
	pages		int null,
	status		smallint)

/*
** Fully qualify table name.
*/
if @table_owner is null
begin	/* If unqualified table name */
	select @full_table_name = @table_name
end
else
begin	/* Qualified table name */
	select @full_table_name = @table_owner + '.' + @table_name
end

/*
** Start at lowest index id, while loop through indexes. 
** Create a row in #TmpIndex for every column in sysindexes, each is
** followed by an row in #TmpIndex with table statistics for the preceding
** index.
*/
select @indid = min(indid)
	from sysindexes
	where id = object_id(@full_table_name)
		and indid > 0
		and indid < 255

while @indid != NULL
begin
	insert #TmpIndex	/* Add all columns that are in index */
	select
		db_name(),		/* table_qualifier */
		user_name(o.uid),	/* table_owner	   */
		o.name,			/* table_name	   */
		o.name, 		/* index_qualifier */
		x.name,			/* index_name	   */
		0,			/* non_unique	   */
		1,			/* SQL_INDEX_CLUSTERED */
		colid,			/* seq_in_index	   */
		INDEX_COL(@full_table_name,indid,colid),/* column_name	   */
		"A",			/* collation	   */
		@indid,			/* index_id 	   */
		rowcnt(x.doampg),	/* cardinality	   */
		data_pgs(x.id,doampg),	/* pages	   */
		x.status		/* status	   */
	from sysindexes x, syscolumns c, sysobjects o
	where x.id = object_id(@full_table_name)
		and x.id = o.id
		and x.id = c.id
		and c.colid < keycnt+(x.status&16)/16
		and x.indid = @indid

	/*
	** Save last index and increase index id to next higher value.
	*/
	select @lastindid = @indid
	select @indid = NULL

	select @indid = min(indid)
	from sysindexes
	where id = object_id(@full_table_name)
		and indid > @lastindid
		and indid < 255
end

update #TmpIndex
	set non_unique = 1
	where status&2 != 2 /* If non-unique index */

update #TmpIndex
	set
		type = 3,		/* SQL_INDEX_OTHER */
		cardinality = NULL,
		pages = NULL
	where index_id > 1		/* If non-clustered index */

/* 
** Now add row with table statistics 
*/
insert #TmpIndex
	select
		db_name(),			/* table_qualifier */
		user_name(o.uid),		/* table_owner	   */
		o.name, 			/* table_name	   */
		null,				/* index_qualifier */
		null,				/* index_name	   */
		null,				/* non_unique	   */
		0,				/* SQL_table_STAT  */
		null,				/* seq_in_index	*/
		null,				/* column_name	   */
		null,				/* collation	   */
		0,				/* index_id 	   */
		rowcnt(x.doampg),		/* cardinality	   */
		data_pgs(x.id,doampg),		/* pages	   */
		0				/* status	   */
	from sysindexes x, sysobjects o
	where o.id = object_id(@full_table_name)
		and x.id = o.id
		and (x.indid = 0 or x.indid = 1)	
	/*  
	** If there are no indexes
	** then table stats are in a row with indid = 0
	*/

if @is_unique != 'Y'	
begin
	/* If all indexes desired */
	select
		table_qualifier,
		table_owner,
		table_name,
		non_unique,
		index_qualifier,
		index_name,
		type,
		seq_in_index,
		column_name,
		collation,
		cardinality,
		pages
	from #TmpIndex
	where index_name like @index_name 	/* If matching name */
		or index_name is null		/* If SQL_table_STAT row */
	order by non_unique, type, index_name, seq_in_index
end
else	
begin
	/* else only unique indexes desired */
	select
		table_qualifier,
		table_owner,
		table_name,
		non_unique,
		index_qualifier,
		index_name,
		type,
		seq_in_index,
		column_name,
		collation,
		cardinality,
		pages
	from #TmpIndex
	where (non_unique = 0 			/* If unique */
		or non_unique is NULL)		/* If SQL_table_STAT row */
		and (index_name like @index_name	/* If matching name */
		or index_name is NULL)		/* If SQL_table_STAT row */
	order by non_unique, type, index_name, seq_in_index

end

drop table #TmpIndex

return (0)
go
grant execute on sp_statistics to public
go
dump tran master with truncate_only
go
/* You didn't see this */
use tempdb
go
grant create table to public
go
use model
go
grant create table to public
go
dump tran master with truncate_only
go

use master
go

/* PROCEDURE SP_TABLES */

if exists (select *
	from sysobjects
		where sysstat & 7 = 4
			and name = 'sp_tables')
begin
	drop procedure sp_tables
end
go
print "Installing sp_tables"
go

/* Sccsid = "@(#) generic/sproc/tables 150.1 10/27/94" */
/*	10.0	1.1	06/16/93	sproc/tables */

/*
** Messages for "sp_tables"         18039
**
** 18039, "Table qualifier must be name of current database"
**
*/
create procedure sp_tables
@table_name		varchar(32)  = null,
@table_owner     varchar(32)  = null,
@table_qualifier varchar(32)  = null,
@table_type		varchar(100) = null
as

declare @msg varchar(90)
declare @type1 varchar(3)
declare @tableindex int

/* temp table */
if (@table_name like "#%" and
   db_name() != "tempdb")
begin
	return(1)
end

/*
** Special feature #1:	enumerate databases when owner and name
** are blank but qualifier is explicitly '%'.  
*/
if @table_qualifier = '%' and
	@table_owner = '' and
	@table_name = ''
begin	

	/*
	** If enumerating databases 
	*/
	select
		table_qualifier = name,
		table_owner = null,
		table_name = null,
		table_type = 'Database',

		/*
		** Remarks are NULL 
		*/
		remarks = convert(varchar(254),null)

		from master..sysdatabases

		/*
		** eliminate MODEL database 
		*/
		where name != 'model'
		order by table_qualifier
end

/*
** Special feature #2:	enumerate owners when qualifier and name
** are blank but owner is explicitly '%'.
*/
else if @table_qualifier = '' and
	@table_owner = '%' and
	@table_name = ''
	begin	

		/*
		** If enumerating owners 
		*/
		select distinct
			table_qualifier = null,
			table_owner = user_name(uid),
			table_name = null,
			table_type = 'Owner',

		/*
		** Remarks are NULL 
		*/
		remarks = convert(varchar(254),null)

		from sysobjects
		order by table_owner
	end
	else
	begin 

		/*
		** end of special features -- do normal processing 
		*/
		if @table_qualifier is not null
		begin
			if db_name() != @table_qualifier
			begin
				if @table_qualifier = ''
				begin  	

					/*
					** If empty qualifier supplied
					** Force an empty result set 
					*/
					select @table_name = ''
					select @table_owner = ''
				end
				else
				begin

					/*
					** If qualifier doesn't match current 
					** database. 
					*/
					print "Table qualifier must be name of current database"
					return 1
				end
			end
		end
		if @table_type is null
		begin	

			/*
			** Select all ODBC supported table types 
			*/
			select @type1 = 'SUV'
		end
		else
		begin
			/*
			** TableType are case sensitive if CS server 
			*/
			select @type1 = null

			/*
			** Add System Tables 
			*/
			if (charindex("'SYSTEM TABLE'",@table_type) != 0)
				select @type1 = @type1 + 'S'

			/*
			** Add User Tables 
			*/
			if (charindex("'TABLE'",@table_type) != 0)
				select @type1 = @type1 + 'U'

			/*
			** Add Views 
			*/
			if (charindex("'VIEW'",@table_type) != 0)
				select @type1 = @type1 + 'V'
		end
		if @table_name is null
		begin	

			/*
			** If table name not supplied, match all 
			*/
			select @table_name = '%'
		end
		else
		begin
			if (@table_owner is null) and 
			   (charindex('%', @table_name) = 0)
			begin	

			/*
			** If owner not specified and table is specified 
			*/
				if exists (select * from sysobjects
					where uid = user_id()
					and name = @table_name
					and (type = 'U' or type = 'V' 
						or type = 'S'))
				begin	

				/*
				** Override supplied owner w/owner of table 
				*/
					select @table_owner = user_name()
				end
			end
		end

		/*
		** If no owner supplied, force wildcard 
		*/
		if @table_owner is null 
			select @table_owner = '%'
		select
			table_qualifier = db_name(),
			table_owner = user_name(o.uid),
			table_name = o.name,
			table_type = rtrim ( 
					substring('SYSTEM TABLE            TABLE       VIEW       ',
					/*
					** 'S'=0,'U'=2,'V'=3 
					*/
					(ascii(o.type)-83)*12+1,12)),

			/*
			** Remarks are NULL
			*/
			remarks = convert(varchar(254),null)

		from sysusers u, sysobjects o
		where
			o.name like @table_name
			and user_name(o.uid) like @table_owner

			/*
			** Only desired types
			*/
			and charindex(substring(o.type,1,1),@type1)! = 0 

			/*
			** constrain sysusers uid for use in subquery 
			*/
			and u.uid = user_id() 
		and (
		suser_id() = 1
		or o.uid = user_id()
		or ((select max(((sign(uid)*abs(uid-16383))*2)+(protecttype&1))
			from sysprotects p
			where p.id =* o.id
			/*
			** get rows for public, current users, user's groups
			*/
		      	and (p.uid = 0 or 
			     p.uid = user_id() or 
			     p.uid =* u.gid) 

			/*
			** check for SELECT, EXECUTE privilege.
			*/
		 	and (action in (193,224)))&1

			/*
			** more magic...normalise GRANT
			** and final magic...compare
			** Grants.
			*/
			) = 1)
		order by table_type, table_qualifier, table_owner, table_name
end
go

grant execute on sp_tables to public
go
dump tran master with truncate_only
go
